//////////////////////////////////////////////////
///////////////Mittelalter Techdemo///////////////
///////////////- Main/////////////////////////////
//////////////////////////////////////////////////
////26.04.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////


//paths
#define PRAGMA_PATH "Scripts"
#define PRAGMA_PATH "Scripts\Postprocessingshaders"
#define PRAGMA_PATH "Scripts\Objectshaders"
#define PRAGMA_PATH "Models"
#define PRAGMA_PATH "Textures"
#define PRAGMA_PATH "Sound"

//gs includes
#include <acknex.h>
#include <default.c>

//#include "Webcam_main.c"

//shader includes
#include "OS_Main.h"
#include "PP_Main.h"
//#include "MtlEdit.c"

//lenseflare include
#include "LF_Main.c"

//other includes
#include "Terrain.c"
#include "Water.c"
#include "Buildings.c"
#include "Trees.c"
#include "Entities.c"
#include "SmallEnvObjects.c"
#include "Feuer.c"
#include "Feuerball.c"
#include "Eisball.c"
#include "Playermovement.c"
#include "Passanten.c"


//splashscreen
BMAP* SplashScreen_bmap = "title.tga";
PANEL* SplashScreen_pan =
{
	bmap = SplashScreen_bmap;
	flags = VISIBLE;
}

//sky
ENTITY* Himmel =
{
	type = "Himmel2+6.tga";
	flags = PASSABLE;
	flags2 = SKY | CUBE | VISIBLE;
}

//function to activate bloom
var BloomChecker = 0;
void Bloom()
{
	if(BloomChecker == 0)
	{
		PP_Bloom_init(camera,40,100,30,2);
		BloomChecker = 1;
	}else
	{
		PP_Bloom_remove(camera);
		BloomChecker = 0;
	}
}

//function to activate radial blur
void radialBlur()
{
	var i;
	PP_RadialBlur_init(camera,0.5,0.5,0.25);
	for(i = -0.25; i < 0.25; i += 0.02*time_step)
	{
		PP_RadialBlur_SetValues(0.5,0.5,0.25-abs(i));
		wait(1);
	}
	
	PP_RadialBlur_remove(camera);
}

//function to activate DoF
var DoFChecker = 0;
void DoF()
{
	if(DoFChecker == 0)
	{
		PP_DoF_init(camera,0,1000,500,30,2);
		DoFChecker = 1;
	}else
	{
		PP_DoF_remove(camera);
		DoFChecker = 0;
	}
}

//function to activate blurred stencil shadows
var SoftStencilChecker = 0;
void SoftStencils()
{
	if(SoftStencilChecker == 0)
	{
		PP_SoftStencilShadows_init(camera,5,300);
		SoftStencilChecker = 1;
	}else
	{
		PP_SoftStencilShadows_remove(camera);
		SoftStencilChecker = 0;
	}
}

//function to change the resolution and recreating the postprocessing shaders
void ChangeResolution()
{
	video_switch(cycle(video_mode+1,6,11),24,NULL);
	PP_Video_Switch();
}


void main()
{
	//application settings
	video_mode = 8;
	video_screen = 2;
	
	//assign key events
	on_f1 = Bloom;
	on_f2 = radialBlur;
	on_f3 = DoF;
	on_f4 = SoftStencils;
	on_f5 = ChangeResolution;
//	on_f6 = NULL;
	
	//terrain
	terrain_chunk = 0;
	
	//shadows
	shadow_stencil = 2;
	mat_shadow.alpha = 50;
	
	bmap_preload(EisRefl_bmap);
	
//	Webcam_init();
	
	//load the level
//	set(SplashScreen_pan,VISIBLE);
//	wait(-1);
	level_load("Level.wmb");
//	wait(-1);
	reset(SplashScreen_pan,VISIBLE);
	
	//fog settings
	d3d_fogcolor1.red = 180;
	d3d_fogcolor1.green = 180;
	d3d_fogcolor1.blue = 200;
	fog_color = 1;
	camera.fog_start = 2000;
	camera.fog_end = 10000;
	
	//sun settings
	sun_light = 100;
	sun_angle.pan = 60;
	sun_angle.tilt = 25;
	vec_set(sun_color,vector(255,255,255));
	
	//mark the sky as such for depthmap rendering
	Himmel.skill41 = floatv(1);
	
	//activate sunflares
	LF_activate(-200,80,15);
	
	//activate per pixel lighting
	OS_O_PerPixelLighting_init(NULL);
	
	//add motionblur
//	PP_MotionBlur_init(camera);
	
//	Bloom();
	
//	PP_HeatHaze_init(camera,500,10000,3,0.02);
//	PP_Blur_init(camera,2,100,100);

//	PP_ColorFilerAnimate_init(camera,10);

	camera.ambient = 0;
	
	while(1)
	{
		camera.arc += key_t-key_g;
		wait(1);
	}
}