//////////////////////////////////////////////////
/////////////////Terrain Tools////////////////////
//////////////////////////////////////////////////
////03.05.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////
#ifndef OS_Tools_WriteTGA_
	#include "OS_Tools_WriteTGA.c"
#endif


//returns the unique name of the shadowmap for this entity
STRING* OS_Terrain_Tools_GetShadowMapName(ENTITY* Ent)
{
	STRING* Temp_str = str_create("#100");
	str_for_entname(Temp_str,Ent);
	str_cat(Temp_str,"_");
	str_cat(Temp_str,level_name);
	str_trunc(Temp_str,4);
	str_cat(Temp_str,".tga");
	return Temp_str;
}

//generates the shadow map and blurs it (this can take several minutes with a high resolution!)
void OS_Terrain_Tools_CreateShadowMap(ENTITY* Ent, int SizeX, int SizeY, int ShadowAmbient, int LightBrightness, int BlurPasses)
{
	var px;
	var py;
	var format;
	var pixel;
	var Dist;
	var temp[3];
	
	var i;
	var pixelcolor[3];
	var pixelalpha;
	var sample1[3];
	var sample2[3];
	var sample3[3];
	var sample4[3];
	var sample5[3];
	var sample6[3];
	var sample7[3];
	var sample8[3];
	var sample9[3]; 
	
	BMAP* canvas;
	var canvas_size[2];
	var pixel_size[2];

	canvas = bmap_createblack(SizeX,SizeY,24);
	canvas_size[0] = bmap_width(canvas);
	canvas_size[1] = bmap_height(canvas);
	
	VECTOR EntCorner1;
	VECTOR EntCorner2;
	vec_for_vertex(EntCorner1,Ent,1);
	vec_for_vertex(EntCorner2,Ent,ent_vertices(Ent));
	
	pixel_size[0] = (EntCorner2.x-EntCorner1.x)/canvas_size[0];
	pixel_size[1] = (EntCorner1.y-EntCorner2.y)/canvas_size[1];

	//Shadow
	py = 0;
	while(py < canvas_size[1])
	{
		px = 0;
		while(px < canvas_size[0])
		{
			// get the world coordinates of the pixel
			temp[0] = EntCorner2.x-pixel_size[0]*px-pixel_size[0]/2;
			temp[1] = EntCorner1.y-pixel_size[1]*py-pixel_size[1]/2;
			c_trace(vector(temp[0],temp[1],Ent.z+50000),vector(temp[0],temp[1],Ent.z-50000),USE_POLYGON|IGNORE_MODELS|IGNORE_SPRITES|IGNORE_MAPS);
			temp[2] = target.z+1;
			you = NULL;
			
			again:
			Dist = c_trace(sun_pos.x,temp[0],IGNORE_YOU|IGNORE_SPRITES|USE_POLYGON|IGNORE_FLAG2);
			
			format = bmap_lock(canvas,0);
			if(Dist == 0)
			{
				pixel = pixel_for_vec(vector(LightBrightness,LightBrightness,LightBrightness),100,format);
			}else
			{
				if(hit.skin1 != NULL)
				{
					pixel = pixel_for_bmap(hit.skin1,hit.u1,hit.v1);
					pixel_to_vec(pixelcolor,pixelalpha,8888,pixel);
					
					if(pixelalpha < 90)
					{
						vec_set(temp[0],target.x);
						goto again;
					}
				}
				
				pixel = pixel_for_vec(vector(ShadowAmbient,ShadowAmbient,ShadowAmbient),100,format);
			}
			pixel_to_bmap(canvas,(canvas_size[0]-1)-px,py,pixel);
			bmap_unlock(canvas);
			
			px += 1;
		}
		py += 1;
	}
	
	
	//Blur	
	i = 0;
	while(i < BlurPasses)
	{
		py = 0;
		while(py < canvas_size[1])
		{
			px = 0;
			while(px < canvas_size[0])
			{
				format = bmap_lock(canvas,0); 
				pixel = pixel_for_bmap(canvas,clamp((canvas_size[0]-1)-px,0,canvas_size[0]-1),clamp(py,0,canvas_size[0]-1));
				pixel_to_vec(sample1,pixelalpha,format,pixel);
				
				pixel = pixel_for_bmap(canvas,clamp((canvas_size[0]-1)-px-1,0,canvas_size[0]-1),clamp(py,0,canvas_size[0]-1));
				pixel_to_vec(sample2,pixelalpha,format,pixel);
				pixel = pixel_for_bmap(canvas,clamp((canvas_size[0]-1)-px-1,0,canvas_size[0]-1),clamp(py+1,0,canvas_size[0]-1));
				pixel_to_vec(sample3,pixelalpha,format,pixel);
				pixel = pixel_for_bmap(canvas,clamp((canvas_size[0]-1)-px,0,canvas_size[0]-1),clamp(py+1,0,canvas_size[0]-1));
				pixel_to_vec(sample4,pixelalpha,format,pixel);
				pixel = pixel_for_bmap(canvas,clamp((canvas_size[0]-1)-px+1,0,canvas_size[0]-1),clamp(py+1,0,canvas_size[0]-1));
				pixel_to_vec(sample5,pixelalpha,format,pixel);
				pixel = pixel_for_bmap(canvas,clamp((canvas_size[0]-1)-px+1,0,canvas_size[0]-1),clamp(py,0,canvas_size[0]-1));
				pixel_to_vec(sample6,pixelalpha,format,pixel);
				pixel = pixel_for_bmap(canvas,clamp((canvas_size[0]-1)-px+1,0,canvas_size[0]-1),clamp(py-1,0,canvas_size[0]-1));
				pixel_to_vec(sample7,pixelalpha,format,pixel);
				pixel = pixel_for_bmap(canvas,clamp((canvas_size[0]-1)-px,0,canvas_size[0]-1),clamp(py-1,0,canvas_size[0]-1));
				pixel_to_vec(sample8,pixelalpha,format,pixel);
				pixel = pixel_for_bmap(canvas,clamp((canvas_size[0]-1)-px-1,0,canvas_size[0]-1),clamp(py-1,0,canvas_size[0]-1));
				pixel_to_vec(sample9,pixelalpha,format,pixel);
				
				pixelcolor[0] = (int)((sample1[0]*7+sample2[0]*2+sample3[0]+sample4[0]*2+sample5[0]+sample6[0]*2+sample7[0]+sample8[0]*2+sample9[0])/19);
				pixelcolor[1] = (int)((sample1[1]*7+sample2[1]*2+sample3[1]+sample4[1]*2+sample5[1]+sample6[1]*2+sample7[1]+sample8[1]*2+sample9[1])/19);
				pixelcolor[2] = (int)((sample1[2]*7+sample2[2]*2+sample3[2]+sample4[2]*2+sample5[2]+sample6[2]*2+sample7[2]+sample8[2]*2+sample9[2])/19);
				
				pixel = pixel_for_vec(pixelcolor,100,format);
				pixel_to_bmap(canvas,(canvas_size[0]-1)-px,py,pixel);
				
				bmap_unlock(canvas);
				
				px += 1;
			}
			py += 1;
		} 
		i += 1;
	}
	
	beep();
	OS_Tools_WriteTGA(OS_Terrain_Tools_GetShadowMapName(Ent),canvas);
	beep();
}

//returns the bmap pointer to the entities shadowmap
BMAP* OS_Terrain_Tools_LoadShadowMap(ENTITY* Ent)
{
	return bmap_create(OS_Terrain_Tools_GetShadowMapName(Ent));
}