//////////////////////////////////////////////////
///////////Objectshaders WriteTGA Tool////////////
//////////////////////////////////////////////////
////03.04.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////
#define OS_Tools_WriteTGA_


//writes char
void OS_Tools_write8(var value, var fhandle)
{
	file_asc_write(fhandle,value);
}

//writes unsigned short
void OS_Tools_write16(var value, var fhandle)
{
  file_asc_write(fhandle,value&255);
  file_asc_write(fhandle,(value>>8)&255);
}

//saves the bmap as .tga file with the given filename (has to be given with .tga ending!)
void OS_Tools_WriteTGA(STRING* FileName, BMAP* canvas)
{
  int i;
  var format;
  var pixel_;
  var pixelalpha;
  int canvas_size[2];
  var temp[3];

  canvas_size[0] = (int)bmap_width(canvas);
  canvas_size[1] = (int)bmap_height(canvas);
  format = bmap_lock(canvas,0);

  var fhandle = file_open_write(FileName);
  
  //------------------------------------write header
  OS_Tools_write8(0,fhandle);
  OS_Tools_write8(0,fhandle);
  OS_Tools_write8(2,fhandle); 					// 10 = RLE compressed tga, 2 = uncompressed tga
  OS_Tools_write16(0,fhandle);
  OS_Tools_write16(0,fhandle);
  OS_Tools_write8(0,fhandle);
  OS_Tools_write16(0,fhandle);
  OS_Tools_write16(0,fhandle);
  OS_Tools_write16(canvas_size[0],fhandle);	// width
  OS_Tools_write16(canvas_size[1],fhandle);	// height
  OS_Tools_write8(24,fhandle);					// bitdepth
  OS_Tools_write8(0,fhandle);
  
  //------------------------------------write image data
  i=0;
  while(i < canvas_size[0]*canvas_size[1])
   {
     pixel_ = pixel_for_bmap(canvas,i%canvas_size[0],(canvas_size[1]-1)-integer(i/canvas_size[0]));
     pixel_to_vec(temp,pixelalpha,format,pixel_);
     
     OS_Tools_write8(temp[0],fhandle); // b
     OS_Tools_write8(temp[1],fhandle); // g
     OS_Tools_write8(temp[2],fhandle); // r
//     OS_Tools_write8(pixelalpha*2.55,fhandle); // a (0..100 -> 0..255)
     
     i += 1;
   }
   
  file_close(fhandle);
  bmap_unlock(canvas);
}