//////////////////////////////////////////////////
///////////Postprocessing Color Filter////////////
//////////////////////////////////////////////////
////09.04.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////
#define PP_ColorFilerAnimate


//transforms the colors with the material matrix
MATERIAL* PP_ColorFilerAnimate_mat =
{
	effect =
	"
		//Variables
		float4 vecTime;
		float4 vecSkill1;
		
		//Texture
		texture TargetMap;
		sampler2D ColorSampler = sampler_state { texture = <TargetMap>;};
		
		//Pixelshader
		float4 PS( float2 texCoord : TEXCOORD0 ) : COLOR0 
		{
			float4 Color = tex2D(ColorSampler,texCoord);
			Color *= lerp(lerp(float4(1,0,0,1),float4(0,1,0,1),sin(vecTime.w*vecSkill1.x)),float4(0,0,1,1),cos(vecTime.w*vecSkill1.x));
			return Color;
		}
		
		technique Tech1
		{
			pass one
			{
				PixelShader = compile ps_2_0 PS();
			}
		}
	";
}

//adjust the matrix values
void PP_ColorFilerAnimate_SetValues(var Speed)
{
	PP_ColorFilerAnimate_mat.skill1 = floatd(Speed,100);
}

//starts the effect
void PP_ColorFilerAnimate_init(VIEW* View, var Speed)
{
	if(d3d_shaderversion >= 2020)
	{
		//pass the values to the material
		PP_ColorFilerAnimate_SetValues(Speed);
		
		//add the effect as a next stage
		PP_Add(PP_ColorFilerAnimate_mat,View,NULL);
	}
}

//removes ColorFiler
void PP_ColorFilerAnimate_remove(VIEW* View)
{
	//remove the stage
	PP_Remove(PP_ColorFilerAnimate_mat,View,NULL);
}