//////////////////////////////////////////////////
///////////////Mittelalter Techdemo///////////////
///////////////- Wasser///////////////////////////
//////////////////////////////////////////////////
////05.01.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////


BMAP* Env_Water_Bump_bmap = "WaterBump.tga";
BMAP* Eff_Waterfall_Spray_bmap = "fall_spray.tga";


/////////////Water/////////////
//title: Water
//section: Shader:
//skill1: BumpmapTilefactor 10
//skill2: BumpmapHeight 10
//skill3: MovementX 0.001
//skill4: MovementY 0.001
action Env_Water_act()
{
	set(my,TRANSLUCENT|FLAG1|PASSABLE);
	my.alpha = 50;
	
	BMAP* Temp_bmap;
	
//	OS_Water_Tools_CreateBlendMap(my,512,512,150);
	Temp_bmap = OS_Water_Tools_LoadBlendMap(my);
	OS_Water_init(my,Env_Water_Bump_bmap,Temp_bmap,my.skill1,my.skill2,my.skill3,my.skill4,2,512,512);
}


//////small Particleshore//////
void Eff_Water_Shore_func_event(PARTICLE *p)
{
	if(p.lifespan > 95)
	{
		p.lifespan = 100;
		p.alpha += 5*time_step;
		if(p.alpha > 25) p.lifespan = 90;
	}else
	{
		p.alpha -= 5*time_step;
	}
		p.size -= 5*time_step;
		if (p.alpha <= 0) p.lifespan = 0;
}

void Eff_Water_Shore_func(PARTICLE *p)
{
	p.bmap = Eff_Waterfall_Spray_bmap;
	p.alpha = 0;
	p.size = random(you.skill4);
	p.flags |= (MOVE|TRANSLUCENT);
	p.event = Eff_Water_Shore_func_event;
	p.lifespan = 100;
}

//title: Small Watershore
//section: Particles:
//skill1: Speed 15
//skill2: RandomSpeed 10
//skill3: RandomAngle 20
//skill4: MaxSize 50
//skill5: Frequence 0.1
action Eff_Water_Shore()
{
	set(my,INVISIBLE);
	VECTOR spray_pos;
	VECTOR spray_direction;
	int spray_vertex;
	
	while(1)
	{
		spray_vertex = random(ent_vertices(my));
		vec_for_vertex(spray_pos,my,spray_vertex);
		vec_for_angle(spray_direction,vector(my.pan+random(my.skill3)-my.skill3*0.5,my.tilt+random(my.skill3)-my.skill3*0.5,my.roll+random(my.skill3)-my.skill3*0.5));
		vec_scale(spray_direction,time_step*my.skill1+random(my.skill2));
		effect(Eff_Water_Shore_func,1,spray_pos,spray_direction);
		
		wait(-my.skill5);
	}
}


///////////Waterfall///////////
void Eff_Waterfall_Spray_func_event(PARTICLE *p)
{
	if(p.lifespan > 95)
	{
		p.lifespan = 100;
		p.alpha += 2*time_step;
		if(p.alpha > 25) p.lifespan = 90;
	}else
	{
		p.alpha -= 2*time_step;
	}
		p.size += 3*time_step;
		p.vel_z -= time_step;
		if (p.alpha <= 0) p.lifespan = 0;
}

void Eff_Waterfall_Spray_func(PARTICLE *p)
{
	p.bmap = Eff_Waterfall_Spray_bmap;
	p.alpha = 0;
	p.size = random(you.skill4);
	p.flags |= (MOVE|TRANSLUCENT);
	p.event = Eff_Waterfall_Spray_func_event;
	p.lifespan = 100;
}

//title: Waterfall Bottomspray
//section: Particles:
//skill1: Speed 15
//skill2: RandomSpeed 10
//skill3: RandomAngle 20
//skill4: MaxSize 50
//skill5: Frequenz 0.2
action Eff_Waterfall_Spray()
{
	set(my,INVISIBLE);
	VECTOR spray_pos;
	VECTOR spray_direction;
	int spray_vertex;
	
	while(1)
	{
		spray_vertex = random(ent_vertices(my));
		vec_for_vertex(spray_pos,my,spray_vertex);
		vec_for_angle(spray_direction,vector(my.pan+random(my.skill3)-my.skill3*0.5,my.tilt+random(my.skill3)-my.skill3*0.5,my.roll+random(my.skill3)-my.skill3*0.5));
		vec_scale(spray_direction,time_step*my.skill1+random(my.skill2));
		effect(Eff_Waterfall_Spray_func,1,spray_pos,spray_direction);
		
		wait(-my.skill5);
	}
}

//title: Waterfall
//section: Shader:
//skill1: Movemtspeed 10
//section: Particles:
//skill2: Speed 10
//skill4: MaxSize 50
action Env_Waterfall_act()
{
	OS_Waterfall_init(my,my.skill1);
	
	VECTOR spray_pos;
	VECTOR spray_direction;
	int spray_vertex;
	while(1)
	{
		spray_vertex = random(ent_vertices(my));
		vec_for_vertex(spray_pos,my,spray_vertex);
		vec_for_normal(spray_direction,my,spray_vertex);
		vec_scale(spray_direction,time_step*random(my.skill2));
		effect(Eff_Waterfall_Spray_func,1,spray_pos,spray_direction);
		
		wait(1);
	}
}